#include "stdafx.h"

#include <grts/structs.model.h>

#include <grtpp_util.h>

#include "wbcanvas/model_view_impl.h"
#include "wbcanvas/model_layer_impl.h"

//================================================================================
// model_View


void model_View::init()
{
}

void model_View::set_data(ImplData *data)
{
  _data= data;
}

model_View::~model_View()
{
}


void model_View::rootLayer(const model_LayerRef &value)
{
  grt::ValueRef ovalue(_rootLayer);
  // this member is owned by this object
  if (_rootLayer.is_valid())
    _rootLayer->get_data()->set_in_view(false);
  _rootLayer= value;
  _rootLayer->get_data()->set_in_view(true);
  owned_member_changed("rootLayer", ovalue, value);
}


void model_View::addConnection(const model_ConnectionRef &connection)
{
  _data->add_connection(connection);
}


void model_View::addFigure(const model_FigureRef &figure)
{
  _data->add_figure(figure);
}


void model_View::deleteLayer(const model_LayerRef &layer)
{
  _data->delete_layer(layer);
}


void model_View::removeConnection(const model_ConnectionRef &connection)
{
  _data->remove_connection(connection);
}


void model_View::removeFigure(const model_FigureRef &figure)
{
  _data->remove_figure(figure);
}


void model_View::selectObject(const model_ObjectRef &object)
{
  _data->select_object(object);
}


void model_View::setPageCounts(long xpages, long ypages)
{
  _data->set_page_counts(xpages, ypages);
}


void model_View::unselectAll()
{
  _data->unselect_all();
}


void model_View::unselectObject(const model_ObjectRef &object)
{
  _data->unselect_object(object);
}

