#ifndef _GTK_HELPERS_H_
#define _GTK_HELPERS_H_

#include <gtkmm.h>
#include <vector>
#include <string>
#include <tree_model.h>

struct ListColumnsModel : public Gtk::TreeModelColumnRecord
{
  public:
    ListColumnsModel() {add(item); }
    Gtk::TreeModelColumn<std::string>  item;
};

Gtk::HBox &create_icon_label(const std::string &icon, const std::string &label);

void open_url(const std::string &url);

Glib::RefPtr<Gtk::ListStore> model_from_string_list(const std::vector<std::string>& list, ListColumnsModel** columns = 0);
void recreate_model_from_string_list(Glib::RefPtr<Gtk::ListStore>, const std::vector<std::string>& list);

void set_glib_string(Glib::ValueBase& value, const std::string& str);
void set_glib_int(Glib::ValueBase& value, const int i);
void set_glib_bool(Glib::ValueBase& value, const bool b);
void set_glib_double(Glib::ValueBase& value, const double d);

void fill_combo_from_string_list(Gtk::ComboBoxText* combo, const std::vector<std::string>& list);
void fill_combo_from_string_list(Gtk::ComboBoxEntryText* combo, const std::vector<std::string>& list);

/*
int          item_index_in_model(Glib::RefPtr<Gtk::TreeModel> store, const std::string& item);
std::string  get_active_item_from_combo(Gtk::ComboBox* combo);
*/

// get_mainwindow is declared here as extern while it is implemented in frontend/linux/workbench/Program.cpp
// and frontend/linux/shell/shell.cpp. get_mainwindow is needed by some functions/methods to
// set dialog transient.
extern Gtk::Window* get_mainwindow();
extern std::string open_file_chooser();
extern std::string save_file_chooser();


#endif /* _GTK_HELPERS_H_ */
