#ifndef _MODEL_VIEW_PANEL_H_
#define _MODEL_VIEW_PANEL_H_

#include "base_panel.h"

#include "workbench/wb_model_view_form.h"
#include "gtk/mdc_gtk_canvas_view.h"
#include "gtk/mdc_gtk_canvas_scroller.h"
#include "mdc_canvas_view_x11.h"

class ModelViewPanel : public mdc::GtkCanvasScroller, public BasePanel
{
  wb::ModelViewForm *_be;  
  mdc::GtkCanvas *_canvas;
  Gdk::Cursor *_cursor;

  bool drag_drop(const Glib::RefPtr<Gdk::DragContext> &context, int x, int y, guint time);

  void drag_data_received(const Glib::RefPtr<Gdk::DragContext> &context, int x, int y,
                          const Gtk::SelectionData &selection_data,
                          guint, guint time);

  void view_realized();
  
public:
  ModelViewPanel(wb::WBContextUI *wb);
  ~ModelViewPanel();

  void init(const std::string &view_id);
  virtual bec::UIForm *get_form() const { return _be; }
  
  void set_title(const std::string &title);
  
  mdc::CanvasView *get_canvas() { return _canvas->get_canvas(); }
  
  void update_tool_cursor();
};


#endif /* _MODEL_VIEW_PANEL_H_ */
